<template>
  <div class="form-group">
    <input class="form-control"
      :name="name"
      :type="type"
      :placeholder="placeholder"
      v-model="selection" />
  </div>
</template>

<script>
  import Store from '../stores/app.store';
  export default {
    name: "survey-input-text",
    props: [ 'name' ],
    data: function() {
      var self = this;
      var slide = Store.getters.slide(this.name);
      var controls = slide.inputs || [];

      function getType() {
        if (controls.length < 1 || !controls[0]) { return 'text'; }
        if (controls[0].text == 'money') { return 'number'; };
        return 'text';
      }

      function getPlaceholder() {
        if (controls.length < 1 || !controls[0]) { return 'text'; }
        if (controls[0].placeholder) { return controls[0].placeholder; }
        if (controls[0].text == 'money') { return 'enter an amount'; };
        return 'enter a value';
      }

      return {
        slide: Store.getters.slide(this.name),
        type: getType(),
        placeholder: getPlaceholder(),
        selection: (Store.getters.slide(this.name) || {}).selection || ''
      };
    },
    watch: {
      selection: function() {
        var self = this;
        var slide = this.slide;
        var input = slide.inputs[0];

        function parse(value) {
          var result = self.type == 'number' ? +(value || 0) : 0
          if (input.addValue) { return result; }
          if (input.subtractValue) { return result * -1; }
          return 0;
        }

        var value = this.selection;

        Store.commit('updateSlide', {
          name: this.name,
          selection: value,
          text: input.changeText,
          valueNote: input.changeValueNote,
          footnote: input.chanageFootnote,
          meta: input.addMeta,
          next: input.next || Store.state.survey.slidesArray[Store.state.survey.currentSlideIndex + 1],
          runningValue: parse(value)
        });

        if (input.addMeta) {
          Store.commit('addMeta', input.addMeta);
        }
      }
    }
  }
</script>

<style scoped>
  .form-group {
    margin: 2em auto auto auto;
    width: 30%;
  }
  .form-control {
    border-radius: 1rem;
  }
</style>
